Attribute VB_Name = "modMain"
Option Explicit

'Used with InitCommonControlsEx() call:
Private Const ICC_USEREX_CLASSES = &H200

Private Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type

Private Declare Function InitCommonControlsEx Lib "comctl32" ( _
    iccex As tagInitCommonControlsEx) As Boolean

'Used for items parsed from the command line, dialog captions:
Public gblnNoExit As Boolean
Public gstrChannel As String
Public gstrDlgCaption As String

'Used for Mailslot name items:
Public Const G_MAILSLOT_PREFIX As String = "LANegram\"
Public Const G_DEFAULT_CHANNEL As String = "0"

Private Sub InitCC()
    Dim iccex As tagInitCommonControlsEx
    
    With iccex
        .lngSize = Len(iccex)
        .lngICC = ICC_USEREX_CLASSES
    End With
    On Error Resume Next
    InitCommonControlsEx iccex
End Sub

Private Function ParseCommandLine() As Boolean
    'Returns True on bad command line.
    Dim strCommand As String
    Dim strParts() As String
    Dim intPart As Integer
    
    gstrDlgCaption = IIf(Len(App.ProductName) > 0, App.ProductName, App.EXEName)
    gstrChannel = G_DEFAULT_CHANNEL
    strCommand = Trim$(Command$())
    If Len(strCommand) > 0 Then
        strParts = Split(strCommand, " ")
        For intPart = 0 To UBound(strParts)
            Select Case LCase$(strParts(intPart))
                Case "/c"
                    intPart = intPart + 1
                    If intPart > UBound(strParts) Then
                        ParseCommandLine = True
                        Exit Function
                    Else
                        gstrChannel = strParts(intPart)
                    End If
                Case "/noexit"
                    gblnNoExit = True
                Case Else
                    ParseCommandLine = True
                    Exit Function
            End Select
        Next
    End If
End Function

Private Sub Usage()
    MsgBox "Receive LANegram Messages." & vbNewLine & vbNewLine _
         & App.EXEName & " [/C <channel>][/NOEXIT]" & vbNewLine _
         & vbNewLine _
         & "/C <channel> optional ""channel"" (no spaces), default is 0." & vbNewLine _
         & "/NOEXIT hide Exit option from tray icon menu, Ctrl-X still available.", _
           vbOKOnly Or vbInformation, _
           gstrDlgCaption
End Sub

Private Sub Main()
    InitCC
    If ParseCommandLine() Then
        Usage
    Else
        frmUI.Show
    End If
End Sub
